unit FlatUtils;

interface

uses
  Windows, CommCtrl, Graphics;

type

  TFlatBorderStyle = (fbsFlat, fbsFrame, fbsExtraFlat, fbs3D);

//procedure Notify(Ctrl: TWinControl; Msg: Integer; lParam: Integer);
procedure DrawBorder(Handle: HWND; const SolidBorder: Boolean; IntWidth: Integer; ABorderStyle: TFlatBorderStyle; ADown: Boolean);

implementation

{procedure Notify(Ctrl: TWinControl; Msg: Integer; lParam: Integer);
var
   M: TMessage;
begin
   M.Msg := msg;
   M.WParam := LongInt(Ctrl);
   M.LParam := lParam;
   M.Result := 0;
   Ctrl.Parent.Broadcast(M);
end;}

procedure DrawBorder(Handle: HWND; const SolidBorder: Boolean; IntWidth: Integer; ABorderStyle: TFlatBorderStyle; ADown: Boolean);
var
  BtnFaceBrush, WindowBrush: HBRUSH;
  DC: HDC;
  R: TRect;
begin
  DC := GetWindowDC(Handle);
  try
    BtnFaceBrush := CreateSolidBrush(GetSysColor(COLOR_INFOBK));
    WindowBrush := CreateSolidBrush(GetSysColor(COLOR_WINDOW));
    try
      GetWindowRect(Handle, R);
      OffsetRect (R, -R.Left, -R.Top);
      if SolidBorder and (not ADown) then
      begin
        if ABorderStyle = fbsFrame then
        begin
          DrawEdge (DC, R, BDR_SUNKENOUTER, BF_RECT or BF_ADJUST);
        end;
        DrawEdge (DC, R, BDR_RAISEDINNER, BF_RECT or BF_ADJUST);
{        FrameRect (DC, R, BtnFaceBrush);
        InflateRect (R, -1, -1);
        if IntWidth > 0 then
          R.Right := R.Left - IntWidth;
        FrameRect (DC, R, WindowBrush);}
      end;
      if (not SolidBorder) then
      begin
        FrameRect (DC, R, BtnFaceBrush);
        InflateRect (R, -1, -1);
        FrameRect (DC, R, BtnFaceBrush);
        InflateRect (R, -1, -1);
        FrameRect (DC, R, WindowBrush);
      end;
      if SolidBorder and ADown then
      begin
        DrawEdge (DC, R, BDR_SUNKENOUTER, BF_RECT or BF_ADJUST);
        {FrameRect (DC, R, BtnFaceBrush);
        InflateRect (R, -1, -1);
        if IntWidth > 0 then
          R.Right := R.Left - IntWidth;
        FrameRect (DC, R, WindowBrush);}
      end;
    finally
      DeleteObject (WindowBrush);
      DeleteObject (BtnFaceBrush);
    end;
  finally
    ReleaseDC(DC, Handle);
  end;
end;

(*
procedure TFlatPanel.Paint;
type
  PPoints = ^TPoints;
  TPoints = array[0..0] of TPoint;

  procedure BevelRect(DC: HDC; const R: TRect);
  var
    Points: array [1..5] of TPoint;
  begin
    Points[1] := Point(R.Left, R.Bottom);
    Points[2] := Point(R.Left, R.Top);
    Points[3] := Point(R.Right, R.Top);
    Points[4] := Point(R.Right, R.Bottom);
    Points[5] := Point(R.Left, R.Bottom);
    Polyline(DC, PPoints(@Points)^, High(Points) + 1);
  end;

var
  BtnFaceBrush, WindowBrush: HBRUSH;
  Pen: HPEN;
  DC: HDC;
  P: array[1..2] of TPoint;
  ColorBtnFace, ColorWindow: COLORREF;
begin
  DC := GetWindowDC(Handle);
  try
    ColorWindow := GetSysColor(COLOR_WINDOW);
    ColorBtnFace := GetSysColor(Integer(Color) and $7FFFFFFF);
    BtnFaceBrush := CreateSolidBrush(ColorBtnFace);
    WindowBrush := CreateSolidBrush(ColorWindow);
    try
      Canvas.Brush.Color := Color;
      Canvas.FillRect(GetClientRect);
      if FShowSeparator then
      begin
        Canvas.Pen.Color := clBtnHighlight;
        Canvas.MoveTo(1, FSeparatorHeight + 1);
        Canvas.LineTo(Width - 1, FSeparatorHeight + 1);
        Canvas.Pen.Color := clBtnShadow;
        Canvas.MoveTo(1, FSeparatorHeight);
        Canvas.LineTo(Width - 1, FSeparatorHeight);
      end;
      if ShowCloseButton then DrawCloseButton(FPressed);
      {if FShowSeparator then
      begin
        Pen := SelectObject(DC, CreatePen(PS_SOLID, 1, GetSysColor(COLOR_BTNHIGHLIGHT)));
        P[1] := Point(1, FSeparatorHeight + 1);
        P[2] := Point(Width - 1, FSeparatorHeight + 1);
        Polygon(DC, P, 2);
        DeleteObject(SelectObject(DC, Pen));
        Pen := SelectObject(DC, CreatePen(PS_SOLID, 1, GetSysColor(COLOR_BTNSHADOW)));
        P[1] := Point(1, FSeparatorHeight);
        P[2] := Point(Width - 1, FSeparatorHeight);
        Polygon(DC, P, 2);
        DeleteObject(SelectObject(DC, Pen));
      end;
      // DrawBorders
      if (BorderStyle = fbsFlat) then
      begin
        if (Borders.LeftBorder) then
        begin
          Pen := SelectObject(DC, CreatePen(PS_SOLID, 1, GetSysColor(COLOR_BTNHIGHLIGHT)));
          P[1] := Point(0, 0);
          P[2] := Point(0, Height);
          Polygon(DC, P, 2);
          DeleteObject(SelectObject(DC, Pen));
        end;
        if (Borders.BottomBorder) then
        begin
          Pen := SelectObject(DC, CreatePen(PS_SOLID, 1, GetSysColor(COLOR_BTNSHADOW)));
          P[1] := Point(0, Height - 1);
          P[2] := Point(Width, Height - 1);
          Polygon(DC, P, 2);
          DeleteObject(SelectObject(DC, Pen));
        end;
        if (Borders.TopBorder) then
        begin
          Pen := SelectObject(DC, CreatePen(PS_SOLID, 1, GetSysColor(COLOR_BTNHIGHLIGHT)));
          P[1] := Point(0, 0);
          P[2] := Point(Width, 0);
          Polygon(DC, P, 2);
          DeleteObject(SelectObject(DC, Pen));
        end;
        if (Borders.RightBorder) then
        begin
          Pen := SelectObject(DC, CreatePen(PS_SOLID, 1, GetSysColor(COLOR_BTNSHADOW)));
          P[1] := Point(Width - 1, 0);
          P[2] := Point(Width - 1, Height);
          Polygon(DC, P, 2);
          DeleteObject(SelectObject(DC, Pen));
        end;
      end else
      begin
        if (Borders.LeftBorder) then
        begin
          Pen := SelectObject(DC, CreatePen(PS_SOLID, 1, GetSysColor(COLOR_BTNSHADOW)));
          P[1] := Point(0, 0);
          P[2] := Point(0, Height);
          Polygon(DC, P, 2);
          DeleteObject(SelectObject(DC, Pen));
          Pen := SelectObject(DC, CreatePen(PS_SOLID, 1, GetSysColor(COLOR_BTNHIGHLIGHT)));
          P[1] := Point(1, 0);
          P[2] := Point(1, Height);
          Polygon(DC, P, 2);
          DeleteObject(SelectObject(DC, Pen));
        end;
        if (Borders.BottomBorder) then
        begin
          Pen := SelectObject(DC, CreatePen(PS_SOLID, 1, GetSysColor(COLOR_BTNSHADOW)));
          P[1] := Point(0, Height - 2);
          P[2] := Point(Width, Height - 2);
          Polygon(DC, P, 2);
          DeleteObject(SelectObject(DC, Pen));
          Pen := SelectObject(DC, CreatePen(PS_SOLID, 1, GetSysColor(COLOR_BTNHIGHLIGHT)));
          P[1] := Point(0, Height - 1);
          P[2] := Point(Width, Height - 1);
          Polygon(DC, P, 2);
          DeleteObject(SelectObject(DC, Pen));
        end;
        if (Borders.TopBorder) then
        begin
          Pen := SelectObject(DC, CreatePen(PS_SOLID, 1, GetSysColor(COLOR_BTNSHADOW)));
          P[1] := Point(0, 0);
          P[2] := Point(Width, 0);
          Polygon(DC, P, 2);
          DeleteObject(SelectObject(DC, Pen));
          Pen := SelectObject(DC, CreatePen(PS_SOLID, 1, GetSysColor(COLOR_BTNHIGHLIGHT)));
          P[1] := Point(0 + Byte(Borders.LeftBorder), 1);
          P[2] := Point(Width, 1);
          Polygon(DC, P, 2);
          DeleteObject(SelectObject(DC, Pen));
        end;
        if (Borders.RightBorder) then
        begin
          Pen := SelectObject(DC, CreatePen(PS_SOLID, 1, GetSysColor(COLOR_BTNHIGHLIGHT)));
          P[1] := Point(Width - 1, 0);
          P[2] := Point(Width - 1, Height);
          Polygon(DC, P, 2);
          DeleteObject(SelectObject(DC, Pen));
          Pen := SelectObject(DC, CreatePen(PS_SOLID, 1, GetSysColor(COLOR_BTNSHADOW)));
          P[1] := Point(Width - 2, 0 + Byte(Borders.TopBorder));
          P[2] := Point(Width - 2, Height - 2*Byte(Borders.BottomBorder));
          Polygon(DC, P, 2);
          DeleteObject(SelectObject(DC, Pen));
        end;
      end;}

    finally
      DeleteObject (WindowBrush);
      DeleteObject (BtnFaceBrush);
    end;
  finally
    ReleaseDC(DC, Handle);
  end;
  inherited Paint;
end;


*)

end.
